Hex Artifact Content

Artifact a91c158a0ca46c8ebc82337f948ea6500adda61e:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 49  2...exit 1.fi..I
00f0: 54 43 4c 56 45 52 53 3d 22 33 2e 34 2e 32 22 0a  TCLVERS="3.4.2".
0100: 49 54 43 4c 56 45 52 53 45 58 54 52 41 3d 22 22  ITCLVERSEXTRA=""
0110: 0a 53 52 43 3d 22 73 72 63 2f 69 74 63 6c 2d 24  .SRC="src/itcl-$
0120: 7b 49 54 43 4c 56 45 52 53 7d 2e 74 61 72 2e 67  {ITCLVERS}.tar.g
0130: 7a 22 0a 53 52 43 55 52 4c 3d 22 68 74 74 70 3a  z".SRCURL="http:
0140: 2f 2f 73 6f 75 72 63 65 66 6f 72 67 65 2e 6e 65  //sourceforge.ne
0150: 74 2f 70 72 6f 6a 65 63 74 73 2f 69 6e 63 72 74  t/projects/incrt
0160: 63 6c 2f 66 69 6c 65 73 2f 25 35 42 49 6e 63 72  cl/files/%5BIncr
0170: 25 32 30 54 63 6c 5f 54 6b 25 35 44 2d 73 6f 75  %20Tcl_Tk%5D-sou
0180: 72 63 65 2f 24 7b 49 54 43 4c 56 45 52 53 7d 2f  rce/${ITCLVERS}/
0190: 69 74 63 6c 24 7b 49 54 43 4c 56 45 52 53 7d 24  itcl${ITCLVERS}$
01a0: 7b 49 54 43 4c 56 45 52 53 45 58 54 52 41 7d 2e  {ITCLVERSEXTRA}.
01b0: 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64 22  tar.gz/download"
01c0: 0a 42 55 49 4c 44 44 49 52 3d 22 24 28 70 77 64  .BUILDDIR="$(pwd
01d0: 29 2f 62 75 69 6c 64 2f 69 74 63 6c 24 7b 49 54  )/build/itcl${IT
01e0: 43 4c 56 45 52 53 7d 22 0a 4f 55 54 44 49 52 3d  CLVERS}".OUTDIR=
01f0: 22 24 28 70 77 64 29 2f 6f 75 74 22 0a 49 4e 53  "$(pwd)/out".INS
0200: 54 44 49 52 3d 22 24 28 70 77 64 29 2f 69 6e 73  TDIR="$(pwd)/ins
0210: 74 22 0a 65 78 70 6f 72 74 20 49 54 43 4c 56 45  t".export ITCLVE
0220: 52 53 20 53 52 43 20 53 52 43 55 52 4c 20 42 55  RS SRC SRCURL BU
0230: 49 4c 44 44 49 52 20 4f 55 54 44 49 52 20 49 4e  ILDDIR OUTDIR IN
0240: 53 54 44 49 52 0a 0a 23 20 53 65 74 20 63 6f 6e  STDIR..# Set con
0250: 66 69 67 75 72 65 20 6f 70 74 69 6f 6e 73 20 66  figure options f
0260: 6f 72 20 74 68 69 73 20 73 75 62 2d 70 72 6f 6a  or this sub-proj
0270: 65 63 74 0a 4c 44 46 4c 41 47 53 3d 22 24 7b 4c  ect.LDFLAGS="${L
0280: 44 46 4c 41 47 53 7d 20 24 7b 4b 43 5f 49 54 43  DFLAGS} ${KC_ITC
0290: 4c 5f 4c 44 46 4c 41 47 53 7d 22 0a 43 46 4c 41  L_LDFLAGS}".CFLA
02a0: 47 53 3d 22 24 7b 43 46 4c 41 47 53 7d 20 24 7b  GS="${CFLAGS} ${
02b0: 4b 43 5f 49 54 43 4c 5f 43 46 4c 41 47 53 7d 22  KC_ITCL_CFLAGS}"
02c0: 0a 43 50 50 46 4c 41 47 53 3d 22 24 7b 43 50 50  .CPPFLAGS="${CPP
02d0: 46 4c 41 47 53 7d 20 24 7b 4b 43 5f 49 54 43 4c  FLAGS} ${KC_ITCL
02e0: 5f 43 50 50 46 4c 41 47 53 7d 22 0a 4c 49 42 53  _CPPFLAGS}".LIBS
02f0: 3d 22 24 7b 4c 49 42 53 7d 20 24 7b 4b 43 5f 49  ="${LIBS} ${KC_I
0300: 54 43 4c 5f 4c 49 42 53 7d 22 0a 65 78 70 6f 72  TCL_LIBS}".expor
0310: 74 20 4c 44 46 4c 41 47 53 20 43 46 4c 41 47 53  t LDFLAGS CFLAGS
0320: 20 43 50 50 46 4c 41 47 53 20 4c 49 42 53 0a 0a   CPPFLAGS LIBS..
0330: 72 6d 20 2d 72 66 20 27 62 75 69 6c 64 27 20 27  rm -rf 'build' '
0340: 6f 75 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64 69  out' 'inst'.mkdi
0350: 72 20 27 62 75 69 6c 64 27 20 27 6f 75 74 27 20  r 'build' 'out' 
0360: 27 69 6e 73 74 27 20 7c 7c 20 65 78 69 74 20 31  'inst' || exit 1
0370: 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 69 66  ..# Determine if
0380: 20 49 74 63 6c 20 69 73 20 65 76 65 6e 20 6e 65   Itcl is even ne
0390: 65 64 65 64 0a 28 0a 09 54 43 4c 5f 56 45 52 53  eded.(..TCL_VERS
03a0: 49 4f 4e 3d 22 75 6e 6b 6e 6f 77 6e 22 0a 09 69  ION="unknown"..i
03b0: 66 20 5b 20 2d 66 20 22 24 7b 54 43 4c 43 4f 4e  f [ -f "${TCLCON
03c0: 46 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e 66 69  FIGDIR}/tclConfi
03d0: 67 2e 73 68 22 20 5d 3b 20 74 68 65 6e 0a 09 09  g.sh" ]; then...
03e0: 73 6f 75 72 63 65 20 22 24 7b 54 43 4c 43 4f 4e  source "${TCLCON
03f0: 46 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e 66 69  FIGDIR}/tclConfi
0400: 67 2e 73 68 22 0a 09 66 69 0a 0a 09 69 66 20 65  g.sh"..fi...if e
0410: 63 68 6f 20 22 24 7b 54 43 4c 5f 56 45 52 53 49  cho "${TCL_VERSI
0420: 4f 4e 7d 22 20 7c 20 67 72 65 70 20 27 5e 38 5c  ON}" | grep '^8\
0430: 2e 5b 34 35 5d 24 27 20 3e 2f 64 65 76 2f 6e 75  .[45]$' >/dev/nu
0440: 6c 6c 3b 20 74 68 65 6e 0a 09 09 23 20 49 74 63  ll; then...# Itc
0450: 6c 20 69 73 20 72 65 71 75 69 72 65 64 20 66 6f  l is required fo
0460: 72 20 54 63 6c 20 38 2e 34 20 61 6e 64 20 54 63  r Tcl 8.4 and Tc
0470: 6c 20 38 2e 35 0a 0a 09 09 65 78 69 74 20 30 0a  l 8.5....exit 0.
0480: 09 66 69 0a 0a 09 69 66 20 5b 20 22 24 7b 54 43  .fi...if [ "${TC
0490: 4c 5f 56 45 52 53 49 4f 4e 7d 22 20 3d 20 22 75  L_VERSION}" = "u
04a0: 6e 6b 6e 6f 77 6e 22 20 5d 3b 20 74 68 65 6e 0a  nknown" ]; then.
04b0: 09 09 23 20 49 66 20 77 65 20 64 6f 6e 27 74 20  ..# If we don't 
04c0: 6b 6e 6f 77 20 77 68 61 74 20 76 65 72 73 69 6f  know what versio
04d0: 6e 20 6f 66 20 54 63 6c 20 77 65 20 61 72 65 20  n of Tcl we are 
04e0: 62 75 69 6c 64 69 6e 67 2c 20 62 75 69 6c 64 0a  building, build.
04f0: 09 09 23 20 49 74 63 6c 20 6a 75 73 74 20 69 6e  ..# Itcl just in
0500: 20 63 61 73 65 2e 0a 0a 09 09 65 78 69 74 20 30   case.....exit 0
0510: 0a 09 66 69 0a 0a 09 23 20 41 6c 6c 20 6f 74 68  ..fi...# All oth
0520: 65 72 20 76 65 72 73 69 6f 6e 73 20 64 6f 20 6e  er versions do n
0530: 6f 74 20 72 65 71 75 69 72 65 20 49 74 63 6c 0a  ot require Itcl.
0540: 09 65 63 68 6f 20 22 53 6b 69 70 70 69 6e 67 20  .echo "Skipping 
0550: 62 75 69 6c 64 69 6e 67 20 49 74 63 6c 2c 20 6e  building Itcl, n
0560: 6f 74 20 72 65 71 75 69 72 65 64 20 66 6f 72 20  ot required for 
0570: 24 7b 54 43 4c 5f 56 45 52 53 49 4f 4e 7d 22 0a  ${TCL_VERSION}".
0580: 09 65 78 69 74 20 31 0a 29 20 7c 7c 20 65 78 69  .exit 1.) || exi
0590: 74 20 30 0a 0a 69 66 20 5b 20 21 20 2d 66 20 22  t 0..if [ ! -f "
05a0: 24 7b 53 52 43 7d 22 20 5d 3b 20 74 68 65 6e 0a  ${SRC}" ]; then.
05b0: 09 6d 6b 64 69 72 20 27 73 72 63 27 20 3e 2f 64  .mkdir 'src' >/d
05c0: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
05d0: 75 6c 6c 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20  ull...if [ ! -d 
05e0: 27 62 75 69 6c 64 73 72 63 27 20 5d 3b 20 74 68  'buildsrc' ]; th
05f0: 65 6e 0a 09 09 72 6d 20 2d 66 20 22 24 7b 53 52  en...rm -f "${SR
0600: 43 7d 2e 74 6d 70 22 0a 09 09 77 67 65 74 20 2d  C}.tmp"...wget -
0610: 4f 20 22 24 7b 53 52 43 7d 2e 74 6d 70 22 20 22  O "${SRC}.tmp" "
0620: 24 7b 53 52 43 55 52 4c 7d 22 20 7c 7c 20 65 78  ${SRCURL}" || ex
0630: 69 74 20 31 0a 09 09 6d 76 20 22 24 7b 53 52 43  it 1...mv "${SRC
0640: 7d 2e 74 6d 70 22 20 22 24 7b 53 52 43 7d 22 0a  }.tmp" "${SRC}".
0650: 09 66 69 0a 66 69 0a 0a 28 0a 09 63 64 20 27 62  .fi.fi..(..cd 'b
0660: 75 69 6c 64 27 20 7c 7c 20 65 78 69 74 20 31 0a  uild' || exit 1.
0670: 0a 09 69 66 20 5b 20 21 20 2d 64 20 27 2e 2e 2f  ..if [ ! -d '../
0680: 62 75 69 6c 64 73 72 63 27 20 5d 3b 20 74 68 65  buildsrc' ]; the
0690: 6e 0a 09 09 67 7a 69 70 20 2d 64 63 20 22 2e 2e  n...gzip -dc "..
06a0: 2f 24 7b 53 52 43 7d 22 20 7c 20 74 61 72 20 2d  /${SRC}" | tar -
06b0: 78 66 20 2d 0a 09 65 6c 73 65 20 20 20 20 0a 09  xf -..else    ..
06c0: 09 63 70 20 2d 72 70 20 2e 2e 2f 62 75 69 6c 64  .cp -rp ../build
06d0: 73 72 63 2f 2a 20 27 2e 2f 27 0a 09 66 69 0a 0a  src/* './'..fi..
06e0: 09 63 64 20 22 24 7b 42 55 49 4c 44 44 49 52 7d  .cd "${BUILDDIR}
06f0: 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 23 20  " || exit 1...# 
0700: 57 6f 72 6b 20 61 72 6f 75 6e 64 20 62 75 67 20  Work around bug 
0710: 77 68 65 72 65 20 49 74 63 6c 20 76 33 2e 34 20  where Itcl v3.4 
0720: 70 69 63 6b 73 20 75 70 20 77 72 6f 6e 67 20 70  picks up wrong p
0730: 6c 61 74 66 6f 72 6d 20 77 68 65 6e 20 63 72 6f  latform when cro
0740: 73 73 2d 63 6f 6d 70 69 6c 69 6e 67 0a 09 63 61  ss-compiling..ca
0750: 73 65 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  se "${TCLCONFIGD
0760: 49 52 7d 22 20 69 6e 0a 09 09 2a 2f 77 69 6e 29  IR}" in...*/win)
0770: 0a 09 09 09 54 45 41 5f 50 4c 41 54 46 4f 52 4d  ....TEA_PLATFORM
0780: 3d 22 77 69 6e 64 6f 77 73 22 0a 09 09 09 65 78  ="windows"....ex
0790: 70 6f 72 74 20 54 45 41 5f 50 4c 41 54 46 4f 52  port TEA_PLATFOR
07a0: 4d 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a 09 09 09  M....;;...*)....
07b0: 54 45 41 5f 50 4c 41 54 46 4f 52 4d 3d 22 75 6e  TEA_PLATFORM="un
07c0: 69 78 22 0a 09 09 09 65 78 70 6f 72 74 20 54 45  ix"....export TE
07d0: 41 5f 50 4c 41 54 46 4f 52 4d 0a 09 09 09 3b 3b  A_PLATFORM....;;
07e0: 0a 09 65 73 61 63 0a 09 73 65 64 20 27 73 40 54  ..esac..sed 's@T
07f0: 45 41 5f 50 4c 41 54 46 4f 52 4d 3d 40 74 65 73  EA_PLATFORM=@tes
0800: 74 20 2d 7a 20 22 24 54 45 41 5f 50 4c 41 54 46  t -z "$TEA_PLATF
0810: 4f 52 4d 22 20 5c 26 5c 26 20 26 40 27 20 63 6f  ORM" \&\& &@' co
0820: 6e 66 69 67 75 72 65 20 3e 20 63 6f 6e 66 69 67  nfigure > config
0830: 75 72 65 2e 6e 65 77 20 26 26 20 63 61 74 20 63  ure.new && cat c
0840: 6f 6e 66 69 67 75 72 65 2e 6e 65 77 20 3e 20 63  onfigure.new > c
0850: 6f 6e 66 69 67 75 72 65 0a 09 72 6d 20 2d 66 20  onfigure..rm -f 
0860: 63 6f 6e 66 69 67 75 72 65 2e 6e 65 77 0a 0a 09  configure.new...
0870: 23 20 42 75 69 6c 64 0a 09 65 63 68 6f 20 22 52  # Build..echo "R
0880: 75 6e 6e 69 6e 67 3a 20 2e 2f 63 6f 6e 66 69 67  unning: ./config
0890: 75 72 65 20 2d 2d 65 6e 61 62 6c 65 2d 73 68 61  ure --enable-sha
08a0: 72 65 64 20 2d 2d 64 69 73 61 62 6c 65 2d 73 79  red --disable-sy
08b0: 6d 62 6f 6c 73 20 2d 2d 70 72 65 66 69 78 3d 5c  mbols --prefix=\
08c0: 22 24 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d 2d  "${INSTDIR}\" --
08d0: 65 78 65 63 2d 70 72 65 66 69 78 3d 5c 22 24 7b  exec-prefix=\"${
08e0: 49 4e 53 54 44 49 52 7d 5c 22 20 2d 2d 6c 69 62  INSTDIR}\" --lib
08f0: 64 69 72 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d  dir=\"${INSTDIR}
0900: 2f 6c 69 62 5c 22 20 2d 2d 77 69 74 68 2d 74 63  /lib\" --with-tc
0910: 6c 3d 5c 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44  l=\"${TCLCONFIGD
0920: 49 52 7d 5c 22 20 24 7b 43 4f 4e 46 49 47 55 52  IR}\" ${CONFIGUR
0930: 45 45 58 54 52 41 7d 22 0a 09 2e 2f 63 6f 6e 66  EEXTRA}".../conf
0940: 69 67 75 72 65 20 2d 2d 65 6e 61 62 6c 65 2d 73  igure --enable-s
0950: 68 61 72 65 64 20 2d 2d 64 69 73 61 62 6c 65 2d  hared --disable-
0960: 73 79 6d 62 6f 6c 73 20 2d 2d 70 72 65 66 69 78  symbols --prefix
0970: 3d 22 24 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d  ="${INSTDIR}" --
0980: 65 78 65 63 2d 70 72 65 66 69 78 3d 22 24 7b 49  exec-prefix="${I
0990: 4e 53 54 44 49 52 7d 22 20 2d 2d 6c 69 62 64 69  NSTDIR}" --libdi
09a0: 72 3d 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69  r="${INSTDIR}/li
09b0: 62 22 20 2d 2d 77 69 74 68 2d 74 63 6c 3d 22 24  b" --with-tcl="$
09c0: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 22 20  {TCLCONFIGDIR}" 
09d0: 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52 41  ${CONFIGUREEXTRA
09e0: 7d 0a 0a 09 65 63 68 6f 20 22 52 75 6e 6e 69 6e  }...echo "Runnin
09f0: 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  g: ${MAKE:-make}
0a00: 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d  "..${MAKE:-make}
0a10: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 65 63 68   || exit 1...ech
0a20: 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 24 7b 4d 41  o "Running: ${MA
0a30: 4b 45 3a 2d 6d 61 6b 65 7d 20 69 6e 73 74 61 6c  KE:-make} instal
0a40: 6c 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61 6b 65  l"..${MAKE:-make
0a50: 7d 20 69 6e 73 74 61 6c 6c 0a 0a 09 6d 6b 64 69  } install...mkdi
0a60: 72 20 22 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62  r "${OUTDIR}/lib
0a70: 22 20 7c 7c 20 65 78 69 74 20 31 0a 09 63 70 20  " || exit 1..cp 
0a80: 2d 72 20 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c  -r "${INSTDIR}/l
0a90: 69 62 22 2f 69 74 63 6c 2a 20 22 24 7b 4f 55 54  ib"/itcl* "${OUT
0aa0: 44 49 52 7d 2f 6c 69 62 2f 22 0a 0a 09 22 24 7b  DIR}/lib/"..."${
0ab0: 53 54 52 49 50 3a 2d 73 74 72 69 70 7d 22 20 2d  STRIP:-strip}" -
0ac0: 67 20 22 24 7b 4f 55 54 44 49 52 7d 22 2f 6c 69  g "${OUTDIR}"/li
0ad0: 62 2f 69 74 63 6c 2a 2f 2a 2e 73 6f 20 3e 2f 64  b/itcl*/*.so >/d
0ae0: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
0af0: 75 6c 6c 0a 0a 09 65 78 69 74 20 30 0a 29 20 7c  ull...exit 0.) |
0b00: 7c 20 65 78 69 74 20 31 0a 0a 65 78 69 74 20 30  | exit 1..exit 0
0b10: 0a                                               .